<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: alexaClientSDK::speechencoder::test Namespace Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1speechencoder.html">speechencoder</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1speechencoder_1_1test.html">test</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#nested-classes">Classes</a> &#124;
<a href="#func-members">Functions</a> &#124;
<a href="#var-members">Variables</a>  </div>
  <div class="headertitle">
<div class="title">alexaClientSDK::speechencoder::test Namespace Reference</div>  </div>
</div><!--header-->
<div class="contents">
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="nested-classes"></a>
Classes</h2></td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1speechencoder_1_1test_1_1_mock_encoder_context.html">MockEncoderContext</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1speechencoder_1_1test_1_1_speech_encoder_test.html">SpeechEncoderTest</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:a1df93863429883638d5e9ed6fe04f9d3"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1speechencoder_1_1test.html#a1df93863429883638d5e9ed6fe04f9d3">TEST_F</a> (<a class="el" href="classalexa_client_s_d_k_1_1speechencoder_1_1test_1_1_speech_encoder_test.html">SpeechEncoderTest</a>, test_startEncoding)</td></tr>
<tr class="separator:a1df93863429883638d5e9ed6fe04f9d3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae399b754a92867ca75597e4d32d2c66c"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1speechencoder_1_1test.html#ae399b754a92867ca75597e4d32d2c66c">TEST_F</a> (<a class="el" href="classalexa_client_s_d_k_1_1speechencoder_1_1test_1_1_speech_encoder_test.html">SpeechEncoderTest</a>, test_shutdownOnBlockingWrite)</td></tr>
<tr class="separator:ae399b754a92867ca75597e4d32d2c66c"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="var-members"></a>
Variables</h2></td></tr>
<tr class="memitem:a5e67a027818217cfedecbb87ebe5620b"><td class="memItemLeft" align="right" valign="top">static constexpr size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1speechencoder_1_1test.html#a5e67a027818217cfedecbb87ebe5620b">FRAME_WORDSIZE</a> = 2</td></tr>
<tr class="memdesc:a5e67a027818217cfedecbb87ebe5620b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Word size per PCM frame = 2byte (16bit)  <a href="#a5e67a027818217cfedecbb87ebe5620b">More...</a><br /></td></tr>
<tr class="separator:a5e67a027818217cfedecbb87ebe5620b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad8130c2a6a60e67c80793ceb7b686f0e"><td class="memItemLeft" align="right" valign="top">static constexpr int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1speechencoder_1_1test.html#ad8130c2a6a60e67c80793ceb7b686f0e">NUM_AUDIO_WRITE</a> = 100</td></tr>
<tr class="memdesc:ad8130c2a6a60e67c80793ceb7b686f0e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Number of dummy frames that will be sent to encoder.  <a href="#ad8130c2a6a60e67c80793ceb7b686f0e">More...</a><br /></td></tr>
<tr class="separator:ad8130c2a6a60e67c80793ceb7b686f0e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ade9024706d425b80fe2a2200a919b9d2"><td class="memItemLeft" align="right" valign="top">static constexpr size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1speechencoder_1_1test.html#ade9024706d425b80fe2a2200a919b9d2">MOCK_ENCODER_INPUT_FRAME_SIZE</a> = 4</td></tr>
<tr class="memdesc:ade9024706d425b80fe2a2200a919b9d2"><td class="mdescLeft">&#160;</td><td class="mdescRight">Input frame size for mock encoder. Will accept 2 frames. (2 * 2byte = 4)  <a href="#ade9024706d425b80fe2a2200a919b9d2">More...</a><br /></td></tr>
<tr class="separator:ade9024706d425b80fe2a2200a919b9d2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a69cc85a33b566b9bfd7e27d94b8cc269"><td class="memItemLeft" align="right" valign="top">static constexpr size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1speechencoder_1_1test.html#a69cc85a33b566b9bfd7e27d94b8cc269">MOCK_ENCODER_OUTPUT_FRAME_SIZE</a> = 4</td></tr>
<tr class="memdesc:a69cc85a33b566b9bfd7e27d94b8cc269"><td class="mdescLeft">&#160;</td><td class="mdescRight">Output frame size for mock encoder. Will output 2 frames per encode. (2 * 2byte = 4)  <a href="#a69cc85a33b566b9bfd7e27d94b8cc269">More...</a><br /></td></tr>
<tr class="separator:a69cc85a33b566b9bfd7e27d94b8cc269"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9583a563054f0c4bcdd3993da12a5134"><td class="memItemLeft" align="right" valign="top">static constexpr size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1speechencoder_1_1test.html#a9583a563054f0c4bcdd3993da12a5134">INPUT_WORD_COUNT</a> = 4096</td></tr>
<tr class="memdesc:a9583a563054f0c4bcdd3993da12a5134"><td class="mdescLeft">&#160;</td><td class="mdescRight">Number of words in input stream SDS buffer (must be large enough to fill encoder's output stream)  <a href="#a9583a563054f0c4bcdd3993da12a5134">More...</a><br /></td></tr>
<tr class="separator:a9583a563054f0c4bcdd3993da12a5134"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a995fc0dc3c2c28a790d17896a696da0a"><td class="memItemLeft" align="right" valign="top">static auto&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1speechencoder_1_1test.html#a995fc0dc3c2c28a790d17896a696da0a">PROCESSING_TIMEOUT</a> = std::chrono::milliseconds(200)</td></tr>
<tr class="memdesc:a995fc0dc3c2c28a790d17896a696da0a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Short timeout (needs to be greater than <code><a class="el" href="classalexa_client_s_d_k_1_1speechencoder_1_1_speech_encoder.html">SpeechEncoder</a>'s</code> BLOCKING writer timeout).  <a href="#a995fc0dc3c2c28a790d17896a696da0a">More...</a><br /></td></tr>
<tr class="separator:a995fc0dc3c2c28a790d17896a696da0a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2316e7071fcf96c86b3fa1b1cf02630d"><td class="memItemLeft" align="right" valign="top">static constexpr unsigned int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1speechencoder_1_1test.html#a2316e7071fcf96c86b3fa1b1cf02630d">MAX_COMPRESSION_FACTOR</a> = 10</td></tr>
<tr class="memdesc:a2316e7071fcf96c86b3fa1b1cf02630d"><td class="mdescLeft">&#160;</td><td class="mdescRight">The maximum factor of compression we expect to encounter.  <a href="#a2316e7071fcf96c86b3fa1b1cf02630d">More...</a><br /></td></tr>
<tr class="separator:a2316e7071fcf96c86b3fa1b1cf02630d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aad1b9805df962fa3ab85cb9a512eeed6"><td class="memItemLeft" align="right" valign="top">static const <a class="el" href="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_audio_format.html">AudioFormat</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1speechencoder_1_1test.html#aad1b9805df962fa3ab85cb9a512eeed6">MOCK_ENCODER_FORMAT</a></td></tr>
<tr class="memdesc:aad1b9805df962fa3ab85cb9a512eeed6"><td class="mdescLeft">&#160;</td><td class="mdescRight">Output format for mock encoder.  <a href="#aad1b9805df962fa3ab85cb9a512eeed6">More...</a><br /></td></tr>
<tr class="separator:aad1b9805df962fa3ab85cb9a512eeed6"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Function Documentation</h2>
<a id="a1df93863429883638d5e9ed6fe04f9d3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1df93863429883638d5e9ed6fe04f9d3">&#9670;&nbsp;</a></span>TEST_F() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">alexaClientSDK::speechencoder::test::TEST_F </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classalexa_client_s_d_k_1_1speechencoder_1_1test_1_1_speech_encoder_test.html">SpeechEncoderTest</a>&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">test_startEncoding&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="ae399b754a92867ca75597e4d32d2c66c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae399b754a92867ca75597e4d32d2c66c">&#9670;&nbsp;</a></span>TEST_F() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">alexaClientSDK::speechencoder::test::TEST_F </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classalexa_client_s_d_k_1_1speechencoder_1_1test_1_1_speech_encoder_test.html">SpeechEncoderTest</a>&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">test_shutdownOnBlockingWrite&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Test if encoding thread will exit if encoder output is not being consumed on exit. </p>

</div>
</div>
<h2 class="groupheader">Variable Documentation</h2>
<a id="a5e67a027818217cfedecbb87ebe5620b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5e67a027818217cfedecbb87ebe5620b">&#9670;&nbsp;</a></span>FRAME_WORDSIZE</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">constexpr size_t alexaClientSDK::speechencoder::test::FRAME_WORDSIZE = 2</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Word size per PCM frame = 2byte (16bit) </p>

</div>
</div>
<a id="a9583a563054f0c4bcdd3993da12a5134"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9583a563054f0c4bcdd3993da12a5134">&#9670;&nbsp;</a></span>INPUT_WORD_COUNT</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">constexpr size_t alexaClientSDK::speechencoder::test::INPUT_WORD_COUNT = 4096</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Number of words in input stream SDS buffer (must be large enough to fill encoder's output stream) </p>

</div>
</div>
<a id="a2316e7071fcf96c86b3fa1b1cf02630d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2316e7071fcf96c86b3fa1b1cf02630d">&#9670;&nbsp;</a></span>MAX_COMPRESSION_FACTOR</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">constexpr unsigned int alexaClientSDK::speechencoder::test::MAX_COMPRESSION_FACTOR = 10</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>The maximum factor of compression we expect to encounter. </p>

</div>
</div>
<a id="aad1b9805df962fa3ab85cb9a512eeed6"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aad1b9805df962fa3ab85cb9a512eeed6">&#9670;&nbsp;</a></span>MOCK_ENCODER_FORMAT</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_audio_format.html">AudioFormat</a> alexaClientSDK::speechencoder::test::MOCK_ENCODER_FORMAT</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<b>Initial value:</b><div class="fragment"><div class="line">= {</div><div class="line">    .encoding = AudioFormat::Encoding::LPCM,</div><div class="line">    .endianness = AudioFormat::Endianness::LITTLE,</div><div class="line">    .sampleRateHz = 16000,</div><div class="line">    .sampleSizeInBits = <a class="code" href="namespacealexa_client_s_d_k_1_1speechencoder_1_1test.html#a5e67a027818217cfedecbb87ebe5620b">FRAME_WORDSIZE</a> * CHAR_BIT,</div><div class="line">    .numChannels = 1,</div><div class="line">    .dataSigned = <span class="keyword">false</span>,</div><div class="line">    .layout = AudioFormat::Layout::INTERLEAVED,</div><div class="line">}</div><div class="ttc" id="namespacealexa_client_s_d_k_1_1speechencoder_1_1test_html_a5e67a027818217cfedecbb87ebe5620b"><div class="ttname"><a href="namespacealexa_client_s_d_k_1_1speechencoder_1_1test.html#a5e67a027818217cfedecbb87ebe5620b">alexaClientSDK::speechencoder::test::FRAME_WORDSIZE</a></div><div class="ttdeci">static constexpr size_t FRAME_WORDSIZE</div><div class="ttdoc">Word size per PCM frame = 2byte (16bit) </div><div class="ttdef"><b>Definition:</b> SpeechEncoderTest.cpp:38</div></div>
</div><!-- fragment -->
<p>Output format for mock encoder. </p>

</div>
</div>
<a id="ade9024706d425b80fe2a2200a919b9d2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ade9024706d425b80fe2a2200a919b9d2">&#9670;&nbsp;</a></span>MOCK_ENCODER_INPUT_FRAME_SIZE</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">constexpr size_t alexaClientSDK::speechencoder::test::MOCK_ENCODER_INPUT_FRAME_SIZE = 4</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Input frame size for mock encoder. Will accept 2 frames. (2 * 2byte = 4) </p>

</div>
</div>
<a id="a69cc85a33b566b9bfd7e27d94b8cc269"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a69cc85a33b566b9bfd7e27d94b8cc269">&#9670;&nbsp;</a></span>MOCK_ENCODER_OUTPUT_FRAME_SIZE</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">constexpr size_t alexaClientSDK::speechencoder::test::MOCK_ENCODER_OUTPUT_FRAME_SIZE = 4</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Output frame size for mock encoder. Will output 2 frames per encode. (2 * 2byte = 4) </p>

</div>
</div>
<a id="ad8130c2a6a60e67c80793ceb7b686f0e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad8130c2a6a60e67c80793ceb7b686f0e">&#9670;&nbsp;</a></span>NUM_AUDIO_WRITE</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">constexpr int alexaClientSDK::speechencoder::test::NUM_AUDIO_WRITE = 100</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Number of dummy frames that will be sent to encoder. </p>

</div>
</div>
<a id="a995fc0dc3c2c28a790d17896a696da0a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a995fc0dc3c2c28a790d17896a696da0a">&#9670;&nbsp;</a></span>PROCESSING_TIMEOUT</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">auto alexaClientSDK::speechencoder::test::PROCESSING_TIMEOUT = std::chrono::milliseconds(200)</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Short timeout (needs to be greater than <code><a class="el" href="classalexa_client_s_d_k_1_1speechencoder_1_1_speech_encoder.html">SpeechEncoder</a>'s</code> BLOCKING writer timeout). </p>

</div>
</div>
</div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
